
from .base import Base
from math import sqrt

class System(Base):
  def define(self):
    self.x:int = 0
    self.y:int = 0
    self.type:str = 'unknown'
  
  def update(self, d):
    self.seta('x', d)
    self.seta('y', d)
    self.seta('type', d)
    
  @classmethod
  def ext(self):
    return 'stm'
  
  def path(self):
    sector, symbol = self.symbol.split('-')
    return f'atlas/{sector}/{symbol[0:1]}/{self.symbol}.{self.ext()}'
  
  def distance(self, other):
    return int(sqrt((self.x - other.x) ** 2 + (self.y - other.y) ** 2))
  
  def sector(self):
    return self.symbol.split('-')[0]
